//   Copyright 2012 Georg-August-Universität Göttingen, Germany
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

package de.ugoe.cs.autoquest.plugin.html.commands;

import java.io.File;
import java.util.List;

import de.ugoe.cs.autoquest.plugin.html.HTMLLogTextInputPseudomizer;
import de.ugoe.cs.util.console.Command;
import de.ugoe.cs.util.console.Console;

/**
 * <p>
 * TODO comment
 * </p>
 * 
 * @author Patrick Harms
 * @version 1.0
 */
public class CMDpseudomizeHTMLTextInputs implements Command {

    /*
     * (non-Javadoc)
     * 
     * @see de.ugoe.cs.util.console.Command#run(java.util.List)
     */
    @Override
    public void run(List<Object> parameters) {
        String path;

        try {
            path = (String) parameters.get(0);
        }
        catch (Exception e) {
            throw new IllegalArgumentException("illegal parameters provided: " + e);
        }

        File directory = new File(path);
        if (!directory.isDirectory()) {
            Console.printerrln(path + " is not a directory");
            return;
        }

        pseudomizeTextInputsInDirectory(directory);

    }

    /**
     * 
     */
    private void pseudomizeTextInputsInDirectory(File directory) {
        if (directory.isDirectory()) {
            File[] children = directory.listFiles();
            
            for (File child : children) {
                pseudomizeTextInputsInDirectory(child);
            }
        }
        else if (directory.isFile()) {
            HTMLLogTextInputPseudomizer pseudomizer = new HTMLLogTextInputPseudomizer();
            pseudomizer.pseudomizeFile(directory);
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see de.ugoe.cs.util.console.Command#help()
     */
    @Override
    public String help() {
        return "pseudomizeHTMLTextInputs <directory>";
    }

}
